<?php

function mryrm_create_setting_tables() {
    global $wpdb;
    
    // setting_table
    $mryrm_sql = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}mryrm_setting(
                    id int(11) unsigned NOT NULL auto_increment,
                    mryrm_url_type varchar(50) CHARACTER SET utf8 DEFAULT NULL, 
                    mryrm_key varchar(50) CHARACTER SET utf8 DEFAULT NULL, 
                    head_title varchar(150) CHARACTER SET utf8 DEFAULT NULL,                     
                    show_star tinyint(1) DEFAULT '1',
                    show_order_by varchar(15) CHARACTER SET utf8 DEFAULT NULL,
                    show_order_type varchar(15) CHARACTER SET utf8 DEFAULT NULL,
                    show_total int(5) DEFAULT NULL,
                    is_show_date tinyint(1) NOT NULL,
                    is_show_title tinyint(1) NOT NULL,
                    is_show_rating tinyint(1) DEFAULT '1',
                    is_show_author tinyint(1) DEFAULT '1',
                    is_show_bullet tinyint(1) DEFAULT '1',
                    is_show_icon tinyint(1) NOT NULL DEFAULT '0',
                    is_show_credit tinyint(1) DEFAULT '0',
                    is_multi_location tinyint(1) DEFAULT '0',
                    latitude varchar(100) CHARACTER SET utf8 DEFAULT NULL,
                    longitude varchar(100) CHARACTER SET utf8 DEFAULT NULL,
                    is_location_new_line tinyint(1) DEFAULT '0',
                    icon_position varchar(20) CHARACTER SET utf8 DEFAULT NULL,                    
                    content_align varchar(20) CHARACTER SET utf8 DEFAULT NULL,                    
                    widget_type varchar(20) CHARACTER SET utf8 DEFAULT NULL,                    
                    bg_color varchar(25) CHARACTER SET utf8 DEFAULT NULL,
                    title_color varchar(25) CHARACTER SET utf8 DEFAULT '#000000',
                    text_color varchar(25) CHARACTER SET utf8 DEFAULT '#000000',
                    star_color varchar(25) CHARACTER SET utf8 DEFAULT '#ffaf00',
                    author_color varchar(25) CHARACTER SET utf8 DEFAULT '#000000',
                    custom_css text CHARACTER SET utf8,
                    nav_css text CHARACTER SET utf8,
                    nav_active_css text CHARACTER SET utf8,
                    review_keyword text CHARACTER SET utf8,
                    city_group text CHARACTER SET utf8,
                    review_group text CHARACTER SET utf8,
                    keyword_separator varchar(10) CHARACTER SET utf8 NOT NULL DEFAULT 'For',                  
                    org_name varchar(150) CHARACTER SET utf8 DEFAULT NULL,
                    org_city varchar(50) CHARACTER SET utf8 DEFAULT NULL,
                    org_state varchar(25) CHARACTER SET utf8 DEFAULT NULL,
                    org_phone varchar(25) CHARACTER SET utf8 DEFAULT NULL,
                    org_type varchar(50) CHARACTER SET utf8 DEFAULT 'Service',
                    org_url varchar(255) CHARACTER SET utf8 DEFAULT NULL,
                    org_logo_url text CHARACTER SET utf8,
                    org_address varchar(255) CHARACTER SET utf8 DEFAULT NULL,
                    org_address_line varchar(255) CHARACTER SET utf8 DEFAULT NULL,
                    org_zipcode varchar(25) CHARACTER SET utf8 DEFAULT NULL,
                    wp_short_code varchar(100) CHARACTER SET utf8 DEFAULT '[mryrm_review_slider]',
                    is_abc tinyint(1) NOT NULL,
                    created_at datetime NOT NULL,
                    updated_at datetime NOT NULL,
                    PRIMARY KEY (id)
        );";

    $wpdb->query($mryrm_sql);
    
}  
    
function mryrm_create_reviews_tables() {
    global $wpdb;  
    
    // review_table
    $mryrm_sql = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}mryrm_reviews(
                id int(11) unsigned NOT NULL auto_increment,
                review_id varchar(50) CHARACTER SET utf8 NOT NULL,                
                source varchar(50) CHARACTER SET utf8 DEFAULT NULL,
                location varchar(150) CHARACTER SET utf8 DEFAULT NULL,
                author varchar(50) CHARACTER SET utf8 DEFAULT NULL,
                rating varchar(5) CHARACTER SET utf8 DEFAULT NULL,
                review longtext CHARACTER SET utf8,
                keyword varchar(100) CHARACTER SET utf8 DEFAULT NULL,
                city varchar(100) CHARACTER SET utf8 DEFAULT NULL,
                state varchar(50) CHARACTER SET utf8 DEFAULT NULL,
                review_type tinyint(1) NOT NULL DEFAULT '0' COMMENT '0 = General, 1 = Caregiver',
                designation varchar(100) CHARACTER SET utf8 DEFAULT NULL,
                is_publish tinyint(1) NOT NULL DEFAULT '1' COMMENT '1 = Publish, 0 = Unpublish',
                created_at datetime DEFAULT NULL,
                updated_at datetime DEFAULT NULL,            
                PRIMARY KEY (id)
        );";

    $wpdb->query($mryrm_sql);
    
  }

function mryrm_update_tables() {
        
    global $wpdb;
    
    // v:1.7
    $table_name_1 = $wpdb->prefix . 'mryrm_reviews';
    $row_1 = $wpdb->get_results(  "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS
        WHERE table_name = '$table_name_1' AND column_name = 'review_type'"  );
    if(empty($row_1)){
        $alter_sql_1 = "ALTER TABLE {$wpdb->prefix}mryrm_reviews 
            ADD `review_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0 = General, 1 = Caregiver'  AFTER `state`,
            ADD `designation` varchar(100) CHARACTER SET utf8 DEFAULT NULL  AFTER `review_type`
        ;";
        $wpdb->query($alter_sql_1);
    }
    // v:1.8             
    $table_name_2 = $wpdb->prefix . 'mryrm_reviews';
    $row_2 = $wpdb->get_results(  "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS
        WHERE table_name = '$table_name_2' AND column_name = 'location'"  );
    if(empty($row_2)){
        $alter_sql_2 = "ALTER TABLE {$wpdb->prefix}mryrm_reviews 
        ADD `location` varchar(150) CHARACTER SET utf8 COLLATE utf8_general_ci NULL  AFTER `source`;";
        $wpdb->query($alter_sql_2);
    }     
    
    
    // v:1.8                  
    $table_name_3 = $wpdb->prefix . 'mryrm_setting'; 
    $row_3 = $wpdb->get_results(  "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS
        WHERE table_name = '$table_name_3' AND column_name = 'is_multi_location'"  );
    if(empty($row_3)){
        $alter_sql_3 = "ALTER TABLE {$wpdb->prefix}mryrm_setting 
                      ADD `is_multi_location` tinyint(1) DEFAULT '0'  AFTER `is_show_credit`;";
        $wpdb->query($alter_sql_3);
    }
    $table_name_4 = $wpdb->prefix . 'mryrm_setting'; 
    $row_4 = $wpdb->get_results(  "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS
        WHERE table_name = '$table_name_4' AND column_name = 'latitude'"  );
    if(empty($row_4)){
        $alter_sql_4 = "ALTER TABLE {$wpdb->prefix}mryrm_setting                      
                      ADD `latitude` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL AFTER `is_multi_location`,
                      ADD `longitude` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL AFTER `latitude`;";
        $wpdb->query($alter_sql_4);
    }     
}
?>